/*
 * The MIT License
 *
 * Copyright 2013 Dra0211.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
package kinugasa.game.logic;

import kinugasa.contents.resource.Nameable;
import kinugasa.util.annotations.Internal;

/**
 * 1つのコマンドライン引数要素です.
 * <br>
 * この要素がコマンドライン引数として送信された場合、この要素のisOnは必ずtrueを返します。
 * ただし送信されなかったコマンドも、CDMArgsに登録されます。<br>
 * <br>
 * フラグ型の引数の値は"true"が設定されます。<br>
 * <br>
 * CMDElementの同一性は名前のみが評価されます。これは同じ名前のコマンドライン引数を
 * 送信することがないと考えられるためです。<br>
 * <br>
 * @version 1.0.0 - 2013/04/27_17:09:33<br>
 * @author Dra0211<br>
 */
public final class CMDElement implements Nameable {

	/** この引数の名前です. */
	private String name;
	/** この引数の値です. */
	private String value;

	/**
	 * 新しいCMDElementを作成します.
	 * 値はnullです。<Br>
	 * @param name 一意的な名前を指定します。<br>
	 */
	@Internal
	CMDElement(String name) {
		this.name = name;
	}

	/**
	 * 新しいCMDElementを作成します.
	 * @param name 一意的な名前を指定します。<br>
	 * @param value 値を指定します。<br>
	 */
	@Internal
	CMDElement(String name, String value) {
		this.name = name;
		this.value = value;
	}

	/**
	 * この引数の値を返します.
	 * <li>この引数が起動時に指定されている場合</li>
	 * フラグ型では、"true"が設定されます。<br>
	 * プロパティ型では、イコール"="で指定された値が格納されます。<br>
	 * <br>
	 * <li>この引数が起動時に指定されなかった場合</li>
	 * nullが設定されます。<br>
	 * <br>
	 * @return この引数に設定された値を返します。<br>
	 */
	public String getValue() {
		return value;
	}

	/**
	 * 値をintとして解釈し、取得します.
	 * @return Integer.parseInt(getValue())を返します。<br>
	 * @throws NumberFormatException 値が変換できない場合に投げられます。<br>
	 */
	public int getIntValue() throws NumberFormatException {
		return Integer.parseInt(value);
	}

	/**
	 * 値をfloatとして解釈し、取得します.
	 * @return Float.parseFloat(getValue())を返します。<br>
	 * @throws NumberFormatException 値が変換できない場合に投げられます。<br>
	 */
	public float getFloatValue() throws NumberFormatException {
		return Float.parseFloat(value);
	}

	/**
	 * この引数が起動時に指定されたかを調べます.
	 * @return 起動時に指定された場合はtrueを返します。この値は
	 * getValue()!=nullと同じです。<br>
	 */
	public boolean isOn() {
		return value != null;
	}

	@Override
	public String getName() {
		return name;
	}

	@Override
	public int hashCode() {
		int hash = 7;
		hash = 71 * hash + (this.name != null ? this.name.hashCode() : 0);
		hash = 71 * hash + (this.value != null ? this.value.hashCode() : 0);
		return hash;
	}

	@Override
	public boolean equals(Object obj) {
		if (obj == null) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		final CMDElement other = (CMDElement) obj;
		if ((this.name == null) ? (other.name != null) : !this.name.equals(other.name)) {
			return false;
		}
		if ((this.value == null) ? (other.value != null) : !this.value.equals(other.value)) {
			return false;
		}
		return true;
	}

	@Override
	public String toString() {
		return "CMDElement{" + "name=" + name + ", value=" + value + '}';
	}
}
